/*
	PIC18F2550 `USBpLEDC~l[VTv
		ver1.00	2010/11/03	
	
	QFLED݂ɏXɌ܂
*/

#include <p18f2550.h>
#include <timers.h>
#include "bootload.h"

#define ON	1
#define OFF	0
#define LED_BLUE	LATBbits.LATB4
#define LED_RED		LATBbits.LATB5

#define LED_DUTY_MAX			100	//duty̍ōl
#define MAIN_ROUTINE_CYCLE_TIME	12	//C[`̃TCN^C
		//Delay10KTCYx̒lŌvZ
		//Delay10KTCYx1̎Ԃ(4/48000000Hz)*10000 = 1/1200s
		//12*1/1200s = 10ms

#define WRITE_TIMER0_COUNT	0x6A	//Timer0̎
		//	48MHzA0.0001sɊ荞݂𔭐
		//	0.0001 / (4 / 48000000) / 8 = 150
		//	256 - 150 = 106 = 0x6A

//O[oϐ錾
unsigned char led_duty_blue = 0;	//dutyݒ(0ŏA100őS)
unsigned char led_duty_red = 0;		//Ԃdutyݒ(0ŏA100őS)
unsigned char led_duty_count = 0;	//led_pduty̓l

unsigned char led_flash_state = 0;


//	ʃx荞݂͂ɏ܂
//	֐ςĂ͂܂
void isr_high()
{
	if(INTCONbits.TMR0IF == 1)
	{
		INTCONbits.TMR0IF = 0;
		WriteTimer0(WRITE_TIMER0_COUNT);

		led_duty_count++;
		if(led_duty_count >= LED_DUTY_MAX)
			led_duty_count = 0;
			
		if(led_duty_count >= led_duty_blue)
			LED_BLUE = OFF;
		else
			LED_BLUE = ON;

		if(led_duty_count >= led_duty_red)
			LED_RED = OFF;
		else
			LED_RED = ON;
	}
}

//	ʃx荞݂͂ɏ܂
//	֐ςĂ͂܂
void isr_low()
{
}

//	ʏ̏珑܂
void main(void)
{	
	TRISB = 0;	//PORT B͑Sďo͂ɐݒ
	LATB = 0;	//PORT BSOFF

//	^C}0̐ݒ
	OpenTimer0(TIMER_INT_ON & T0_8BIT & T0_SOURCE_INT & T0_PS_1_8);
	WriteTimer0(WRITE_TIMER0_COUNT);

//	荞݊Jn
	RCONbits.IPEN = 1;			//荞ݗDt
	INTCON2bits.TMR0IP = 1;		//^C}0ʃx荞݂ɐݒ
	INTCONbits.TMR0IE = 1;		//^C}0荞݋
	INTCONbits.GIEH = 1;		//ʃx荞݂̋

	
	while(1)
	{
		switch(led_flash_state)
		{
			case 0:		//LED0->MAX
				led_duty_red++;
				if(led_duty_red == LED_DUTY_MAX)
					led_flash_state = 1;
				break;
			case 1:		//LED0->MAX
				led_duty_blue++;
				if(led_duty_blue == LED_DUTY_MAX)
					led_flash_state = 2;
				break;
			case 2:		//LEDMAX->0
				led_duty_red--;
				if(led_duty_red == 0)
					led_flash_state = 3;
				break;
			case 3:		//LED0->MAX
				led_duty_red++;
				if(led_duty_red == LED_DUTY_MAX)
					led_flash_state = 4;
				break;
			case 4:		//LEDMAX->0
				led_duty_blue--;
				if(led_duty_blue == 0)
					led_flash_state = 1;
				break;
			default:
				break;
		}	

		Delay10KTCYx(MAIN_ROUTINE_CYCLE_TIME);
	}
}
